package game;

import sk.thenet.gamestd.bmp.*;

@:bitmap("assets/hu man.png") class AssetMan extends flash.display.BitmapData {}
@:bitmap("assets/hu enemies.png") class AssetEnemies extends flash.display.BitmapData {}
@:bitmap("assets/hu lvl hub.png") class AssetLvlHub extends flash.display.BitmapData {}
@:bitmap("assets/hu lvl grotto.png") class AssetLvlGrotto extends flash.display.BitmapData {}
@:bitmap("assets/hu lvl shrooms.png") class AssetLvlShrooms extends flash.display.BitmapData {}
@:bitmap("assets/hu levels.png") class AssetLevels extends flash.display.BitmapData {}
@:bitmap("assets/hu levels gravity.png") class AssetLevelsGravity extends flash.display.BitmapData {}
@:bitmap("assets/hu levels oneway.png") class AssetLevelsOneway extends flash.display.BitmapData {}
@:bitmap("assets/hu levels pickups.png") class AssetLevelsPickups extends flash.display.BitmapData {}
@:bitmap("assets/hu gui.png") class AssetGUI extends flash.display.BitmapData {}
@:bitmap("assets/hu font.png") class AssetFont extends flash.display.BitmapData {}

@:sound("assets/snd death player.wav") class SoundDeathPlayer extends flash.media.Sound {}
@:sound("assets/snd death.wav") class SoundDeath extends flash.media.Sound {}
@:sound("assets/snd enemy shoot.wav") class SoundEnemyShoot extends flash.media.Sound {}
@:sound("assets/snd hit.wav") class SoundHit extends flash.media.Sound {}
@:sound("assets/snd pickup.wav") class SoundPickup extends flash.media.Sound {}
@:sound("assets/snd select.wav") class SoundSelect extends flash.media.Sound {}
@:sound("assets/snd shoot.wav") class SoundShoot extends flash.media.Sound {}
@:sound("assets/snd startup.wav") class SoundStartup extends flash.media.Sound {}
@:sound("assets/snd walk.wav") class SoundWalk extends flash.media.Sound {}

class Assets {
	public static var aMan:BitmapData;
	public static var aEnemies:BitmapData;
	public static var aManHit:BitmapData;
	public static var aEnemiesHit:BitmapData;
	public static var aLvlHub:BitmapData;
	public static var aLvlGrotto:BitmapData;
	public static var aLvlShrooms:BitmapData;
	public static var aLevels:BitmapData;
	public static var aLevelsGravity:BitmapData;
	public static var aLevelsOneway:BitmapData;
	public static var aLevelsPickups:BitmapData;
	public static var aGUI:BitmapData;
	
	public static var sDeathPlayer:flash.media.Sound;
	public static var sDeath:flash.media.Sound;
	public static var sEnemyShoot:flash.media.Sound;
	public static var sHit:flash.media.Sound;
	public static var sPickup:flash.media.Sound;
	public static var sSelect:flash.media.Sound;
	public static var sShoot:flash.media.Sound;
	public static var sStartup:flash.media.Sound;
	public static var sWalk:flash.media.Sound;
	
	public static var fWhite:BitmapFont;
	public static var fGlow:BitmapFont;
	
	public static var palette:Array<UInt>;
	
	public static function init():Void {
		sDeathPlayer = new SoundDeathPlayer();
		sDeath = new SoundDeath();
		sEnemyShoot = new SoundEnemyShoot();
		sHit = new SoundHit();
		sPickup = new SoundPickup();
		sSelect = new SoundSelect();
		sShoot = new SoundShoot();
		sStartup = new SoundStartup();
		sWalk = new SoundWalk();
		
		aMan = cast(new AssetMan(0, 0));
		aEnemies = cast(new AssetEnemies(0, 0));
		
		aLvlHub = cast(new AssetLvlHub(0, 0));
		aLvlGrotto = cast(new AssetLvlGrotto(0, 0));
		aLvlShrooms = cast(new AssetLvlShrooms(0, 0));
		aLevels = cast(new AssetLevels(0, 0));
		aLevelsGravity = cast(new AssetLevelsGravity(0, 0));
		aLevelsOneway = cast(new AssetLevelsOneway(0, 0));
		aLevelsPickups = cast(new AssetLevelsPickups(0, 0));
		aGUI = cast(new AssetGUI(0, 0));
		palette = [
			0xFF000000 | (228 << 16) | (248 << 8) | (244),
			0xFF000000 | (218 << 16) | (236 << 8) | (240),
			0xFF000000 | (195 << 16) | (219 << 8) | (232),
			0xFF000000 | (143 << 16) | (166 << 8) | (199),
			0xFF000000 | ( 93 << 16) | ( 87 << 8) | (161),
			
			0xFF000000 | (236 << 16) | (243 << 8) | (194),
			0xFF000000 | (194 << 16) | (212 << 8) | (147),
			0xFF000000 | (141 << 16) | (171 << 8) | (111),
			0xFF000000 | ( 98 << 16) | (140 << 8) | ( 72),
			0xFF000000 | ( 37 << 16) | ( 89 << 8) | ( 31),
			
			0xFF000000 | (248 << 16) | (238 << 8) | (147),
			0xFF000000 | (243 << 16) | (204 << 8) | ( 63),
			0xFF000000 | (243 << 16) | (132 << 8) | ( 29),
			0xFF000000 | (184 << 16) | ( 63 << 8) | ( 12),
			0xFF000000 | (128 << 16) | (  4 << 8) | (  0),
			
			0xFF000000 | (103 << 16) | (102 << 8) | (122),
			0xFF000000 | ( 78 << 16) | ( 75 << 8) | ( 87),
			0xFF000000 | ( 54 << 16) | ( 52 << 8) | ( 56),
			0xFF000000 | ( 28 << 16) | ( 27 << 8) | ( 28),
		];
		fWhite = new BitmapFont(cast(new AssetFont(0, 0)), 32, 32, 5, 10, palette[15], 0);
		fGlow = new BitmapFont(cast(new AssetFont(0, 0)), 32, 32, 5, 10, palette[0], palette[18]);
		
		aManHit = cast(new AssetMan(0, 0));
		for (y in 0...aManHit.height){
			for (x in 0...aManHit.width){
				aManHit.set(x, y, (aManHit.get(x, y) & 0xFF000000) | (palette[0] & 0xFFFFFF));
			}
		}
		aEnemiesHit = cast(new AssetEnemies(0, 0));
		for (y in 0...aEnemiesHit.height){
			for (x in 0...aEnemiesHit.width){
				aEnemiesHit.set(x, y, (aEnemiesHit.get(x, y) & 0xFF000000) | (palette[0] & 0xFFFFFF));
			}
		}
	}
}