package game;

import sk.thenet.gamestd.input.*;
import sk.thenet.gamestd.bmp.*;

class EMan extends Entity {
	public var jump_num:Int = 0;
	public var jump_pow:Array<Int> = [0, 0, 0, 0];
	public var jump_max:Array<Int> = [12, 8, 0, 0];
	public var jump_str:Array<Int> = [-2, -2, -2, -2, -2, -3, -3, -3, -4, -4, -5, -3, -1];
	public var jump_start:Bool = false;
	public var jump_end:Bool = false;
	public var jump_cont:Bool = false;
	public var rx:Int = 0;
	public var ry:Int = 0;
	public var walk:Bool = false;
	public var walk_ph:Int = 0;
	public var walk_speed:Int = 2;
	public var facing:Bool = false;
	public var ladder:Bool = false;
	public var ladder_ph:Int = 0;
	public var bullet_cd:Int = 0;
	public var bullet_list:Array<EEBullet> = [];
	public var hit_ph:Int = 0;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_MAN;
		super(Entity.ET_MAN, nlvl, nphsx);
	}
	
	public function hit():Void {
		if (hit_ph == 0){
			Assets.sHit.play();
			hit_ph = 16;
			if (cast(Main.st.cstr, GSGame).damage[cast(Main.st.cstr, GSGame).cmc_sel] > 0)
				cast(Main.st.cstr, GSGame).damage[cast(Main.st.cstr, GSGame).cmc_sel] -= 5;
		}
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		bd.copyPixels(hit_ph != 0 ? ((hit_ph % 4) < 2 ? Assets.aManHit : Assets.aMan) : Assets.aMan,
			pe.xp - 8 - camxi, pe.yp - 8 - camyi, rx << 4, ry << 4, 16, 16);
	}
	
	override public function tick():Void {
		bullet_list = bullet_list.filter(function(a:EEBullet){
			return !a.remove;
		});
		if (hit_ph > 0) hit_ph--;
		if (cast(Main.st.cstr, GSGame).control != GSGame.GC_NORMAL) return;
		var bxv:Int = 0;
		if (Main.st.kb.down[Keyboard.K_A] && bullet_cd == 0){
			Assets.sShoot.play();
			bullet_list.push(new EEBullet(pe.xp, pe.yp, lvl, phsx, facing ? -5 : 5, 0, true));
			bullet_cd = 15;
			bxv = (facing ? 1 : -1);
		}
		if (bullet_cd > 0) bullet_cd--;
		var nxt:Int = pe.xp >> 4;
		var nyt:Int = pe.yp >> 4;
		if (nxt >= 0 && nxt < lvl.width && nyt >= 0 && nyt < lvl.height){
			if (phsx.lvl[nxt + nyt * lvl.width] & Physics.P_LVL_LADDER != 0
				&& (ladder || Main.st.kb.down[Keyboard.K_UP] || Main.st.kb.down[Keyboard.K_DOWN])
				&& !Main.st.kb.down[Keyboard.K_LEFT] && !Main.st.kb.down[Keyboard.K_RIGHT]){
				jump_num = 0;
				jump_pow = [0, 0, 0, 0];
				ladder = true;
				pe.xp = (nxt << 4) + 8;
				pe.xv = 0;
				pe.yv = if (Main.st.kb.down[Keyboard.K_UP] && !Main.st.kb.down[Keyboard.K_DOWN]){
					ladder_ph++;
					-2;
				} else if (!Main.st.kb.down[Keyboard.K_UP] && Main.st.kb.down[Keyboard.K_DOWN]){
					ladder_ph++;
					2;
				} else {
					0;
				};
				rx = ladder_ph < 8 ? 4 : 3;
				ry = 0;
				ladder_ph %= 16;
				return;
			} else if (phsx.lvl[nxt + nyt * lvl.width] & Physics.P_LVL_WATER != 0){
				pe.xv = (if (Main.st.kb.down[Keyboard.K_LEFT] && !Main.st.kb.down[Keyboard.K_RIGHT]){
					facing = true;
					-2;
				} else if (!Main.st.kb.down[Keyboard.K_LEFT] && Main.st.kb.down[Keyboard.K_RIGHT]){
					facing = false;
					2;
				} else {
					0;
				}) + bxv;
				pe.yv = if (Main.st.kb.down[Keyboard.K_UP] && !Main.st.kb.down[Keyboard.K_DOWN]){
					-2;
				} else if (!Main.st.kb.down[Keyboard.K_UP] && Main.st.kb.down[Keyboard.K_DOWN]){
					2;
				} else {
					1;
				};
				rx = 0;
				if (facing){
					ry = 1;
				} else {
					ry = 0;
				}
				jump_num = 1;
				jump_pow = [0, 0, 0, 0];
				return;
			}
		}
		ladder = false;
		ladder_ph = 0;
		var ground:Bool = false;
		if (pe.coly1){
			jump_num = 0;
			jump_pow = [0, 0, 0, 0];
			jump_cont = jump_start ? true : false;
			ground = true;
		}
		if (pe.coly2){
			if (jump_num < jump_pow.length){
				jump_pow[jump_num] = jump_max[jump_num];
			}
		}
		jump_start = false;
		var gravity:Bool = true;
		if (jump_cont){
			if (jump_num < jump_pow.length){
				if (jump_pow[jump_num] < jump_max[jump_num]){
					if (jump_pow[jump_num] == 0) Assets.sWalk.play();
					pe.yv = jump_str[jump_max[jump_num] - jump_pow[jump_num]];
					jump_pow[jump_num]++;
					gravity = false;
				}
			}
		}
		if (!ground && pe.yv < 0 && jump_pow[jump_num] < jump_max[jump_num] && jump_end){
			pe.yv = -2;
		}
		jump_end = false;
		if (pe.yv < 2 && gravity){
			pe.yv++;
		}
		pe.xv = (if (Main.st.kb.down[Keyboard.K_LEFT] && !Main.st.kb.down[Keyboard.K_RIGHT]){
			facing = true;
			if (pe.xv <= -walk_speed){
				-walk_speed;
			} else {
				pe.xv - 1;
			}
		} else if (Main.st.kb.down[Keyboard.K_RIGHT] && !Main.st.kb.down[Keyboard.K_LEFT]){
			facing = false;
			if (pe.xv >= walk_speed){
				walk_speed;
			} else {
				pe.xv + 1;
			}
		} else {
			if (pe.xv < 0){
				pe.xv + 1;
			} else if (pe.xv > 0){
				pe.xv - 1;
			} else {
				0;
			}
		}) + bxv;
		if (ground && (Main.st.kb.down[Keyboard.K_LEFT] != Main.st.kb.down[Keyboard.K_RIGHT])){
			walk = true;
			walk_ph++;
			walk_ph %= 32;
			rx = (walk_ph < 8 ? 1 : (walk_ph >= 16 && walk_ph < 24 ? 2 : 0));
		} else if (ground){
			walk = false;
			walk_ph = 0;
			rx = 0;
		} else {
			if (pe.yv < 0){
				rx = 1;
			} else {
				rx = 2;
			}
		}
		if (facing){
			ry = 1;
		} else {
			ry = 0;
		}
	}
	
	override public function kUp(k:Int):Void {
		if (cast(Main.st.cstr, GSGame).control != GSGame.GC_NORMAL) return;
		if (k == Keyboard.K_UP){
			jump_cont = false;
			jump_end = true;
		}
	}
	
	override public function kDown(k:Int):Void {
		if (cast(Main.st.cstr, GSGame).control != GSGame.GC_NORMAL) return;
		if (k == Keyboard.K_UP){
			jump_start = true;
			jump_cont = true;
			jump_num++;
		}
	}
}