package game;

import sk.thenet.plustd.FM;
import sk.thenet.gamestd.bmp.*;

class EPickup extends Entity {
	public var phase:Int = 0;
	public var phase2:Int = 0;
	public var phasey:Int = 0;
	public var ypos:Array<Int> = [
		-2,
		-2,
		-2,
		-1,
		-1,
		0,
		1,
		1,
		2,
		2,
		2,
		1,
		1,
		0,
		-1,
		-1
	];
	public var small:Bool;
	public var green:Bool;
	public var csi:Int;
	
	public function new(nx:Int, ny:Int, nlvl:Level, nphsx:Physics, nsmall:Bool, ngreen:Bool, ncsi:Int){
		pe = new PhysicsEntity(nx, ny);
		pe.type = PhysicsEntity.PET_PICKUP;
		small = nsmall;
		green = ngreen;
		csi = ncsi;
		super(Entity.ET_PICKUP, nlvl, nphsx);
	}
	
	override public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		if (small){
			bd.copyPixels(Assets.aEnemies, pe.xp + 4 - camxi, pe.yp - camyi + ypos[phasey >> 1], (green ? 8 : 0), 40, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 4 - camxi, pe.yp - camyi + ypos[phasey >> 1], FM.floor(phase / 3) * 8, 32, 8, 8);
		} else {
			bd.copyPixels(Assets.aEnemies, pe.xp + 1 - camxi, pe.yp - camyi + ypos[phasey >> 1], (green ? 8 : 0), 40, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 1 - camxi, pe.yp - camyi + ypos[phasey >> 1], FM.floor(phase / 3) * 8, 32, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 7 - camxi, pe.yp - camyi + ypos[phasey >> 1], (green ? 8 : 0), 40, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 7 - camxi, pe.yp - camyi + ypos[phasey >> 1], FM.floor(phase / 3) * 8, 32, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 4 - camxi, pe.yp + 6 - camyi + ypos[phasey >> 1], (green ? 8 : 0), 40, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp + 4 - camxi, pe.yp + 6 - camyi + ypos[phasey >> 1], FM.floor(phase / 3) * 8, 32, 8, 8);
			bd.copyPixels(Assets.aEnemies, pe.xp - camxi, pe.yp - 1 - camyi + ypos[phasey >> 1], FM.floor(phase2 / 5) * 16, 48, 16, 16);
		}
	}
	
	override public function tick():Void {
		if (lvl.man.pe.xp >= pe.xp && lvl.man.pe.xp < pe.xp + 16 && lvl.man.pe.yp >= pe.yp && lvl.man.pe.yp < pe.yp + 16){
			Assets.sPickup.play();
			lvl.state[csi] = false;
			if (green) cast(Main.st.cstr, GSGame).col_green += (small ? 1 : 5);
			else cast(Main.st.cstr, GSGame).col_red += (small ? 1 : 5);
			pe.remove = true;
			remove = true;
			return;
		}
		phase++;
		phase %= 18;
		phase2++;
		phase2 %= 30;
		phasey++;
		phasey %= 32;
	}
}