package game;

import haxe.ds.Vector;
import sk.thenet.gamestd.bmp.*;

class Water {
	public static var WAVE:Array<Int> = [
		-2,
		-2,
		-1,
		-1,
		-1,
		0,
		0,
		0,
		0,
		1,
		1,
		1,
		2,
		2,
		1,
		1,
		1,
		0,
		0,
		0,
		0,
		-1,
		-1,
		-1
	];
	public static var UPWAVE:Array<Int> = [
		-1,
		0,
		0,
		0,
		1,
		1,
		2,
		0,
		0,
		-1
	];
	public static var TOP:Array<Bool> = [
		true,
		false,
		false,
		false,
		false,
		false,
		true,
		true,
		true,
		false,
		false,
		false,
		true,
		true,
		true,
		true,
		false,
		false,
		false,
		false,
		true,
		false,
		false,
		true,
		true,
		false,
		true,
		false,
		true
	];
	
	public var x:Int;
	public var y:Int;
	public var w:Int;
	public var h:Int;
	public var mask:BitmapData;
	public var phase:Vector<Int>;
	public var hphase:Int;
	
	public function new(nx:Int, ny:Int, nw:Int, nh:Int, nmask:BitmapData){
		x = nx;
		y = ny;
		w = nw;
		h = nh;
		mask = nmask;
		phase = new Vector<Int>(nh);
		for (i in 0...nh){
			phase[i] = 0;
		}
		hphase = 0;
	}
	
	public function render(bd:BitmapData, camxi:Int, camyi:Int):Void {
		if (x - camxi + w < 0 || y - camyi + h < 0 || x - camxi >= 320 || y - camyi >= 240) return;
		var ov = bd.getFullVector();
		var v = bd.getFullVector();
		var oy:Int = y - camyi;
		var sx:Int = x - camxi;
		var sy:Int = oy;
		var sw:Int = w;
		var sh:Int = h;
		if (sx < 0){
			sw += sx;
			sx = 0;
		}
		if (sy < 0){
			sh += sy;
			sy = 0;
		}
		if (sx + sw >= 320){
			sw -= ((sx + sw) - 320);
		}
		if (sy + sh >= 240){
			sh -= ((sy + sh) - 240);
		}
		var i:Int = 0;
		for (y in sy...(sy + sh)){
			i = sx + y * 320;
			for (x in sx...(sx + sw)){
				if (y == oy && TOP[(x + camxi + hphase) % TOP.length]) v[i] = 0xFFC3DBE8;
				else {
					var ti:Int = i + WAVE[phase[(y + camyi + phase.length) % phase.length]];
						//+ UPWAVE[phase[(x + y + camyi + phase.length) % phase.length] % UPWAVE.length] * 320;
					if (ti >= ov.length) ti = ov.length - 1;
					v[i] = ov[ti];
				}
				i++;
			}
		}
		if (Math.random() > .9){
			hphase++;
			hphase %= TOP.length;
		}
		for (i in 0...phase.length){
			if (Math.random() > .8){
				phase[i] = phase[i] + 1;
				phase[i] %= WAVE.length;
			}
		}
		bd.setFullVector(v);
	}
}